<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
    <script>
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

        /*** REGION 2 - Vùng gán sự kiện cho các elements */
        $(document).ready(function () {
            onPageLoading();

            // gán sự kiện
           $("#table-users").on("click", ".edit-user", function() {
                onBtnEditUserClick(this);
           });

           $("#table-users").on("click", ".delete-user", function() {
            onBtnDeleteUserClick(this);
           });
        });

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            // load dữ liệu lên user table
            getDataUsersTable();
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // load data to table
        function getDataUsersTable() {
            $.ajax({
                url: "http://203.171.20.210:8080/crud-api/users/",
                type: "GET",
                success: function (paramUsers) {
                    // load dữ liệu từ mảng users lên table
                    loadUsersDataToTable(paramUsers);
                },
                error: function (err) {
                    console.log(err.status);
                }
            });
        }

        function onBtnEditUserClick(paramButton) {
            var vUserId = $(paramButton).data("id");
            console.log(`UserId: ${vUserId}`);
        }

        function onBtnDeleteUserClick(paramButton) {
            var vUserId = $(paramButton).data("id");
            console.log(`UserId: ${vUserId}`);
        }

        // hàm đổ dữ liệu users lên table
        function loadUsersDataToTable(paramUsers) {
            var vUsersTable = $("#table-users");

            for (let bI = 0; bI < paramUsers.length; bI++) {
                // tạo ra dòng mới và gắn vào table
                let bNewRow = $("<tr>").appendTo(vUsersTable);
                // sau đó, tạo ra các ô tương ứng với các cột, điền dữ liệu cho từng ô rồi gắn vào dòng mới tạo
                $("<td>", { html: paramUsers[bI].id }).appendTo(bNewRow);
                $("<td>", { html: paramUsers[bI].firstname }).appendTo(bNewRow);
                $("<td>", { html: paramUsers[bI].lastname }).appendTo(bNewRow);
                $("<td>", { html: paramUsers[bI].country }).appendTo(bNewRow);
                $("<td>", { html: paramUsers[bI].subject }).appendTo(bNewRow);
                $("<td>", { html: paramUsers[bI].customerType }).appendTo(bNewRow);
                $("<td>", { html: paramUsers[bI].registerStatus }).appendTo(bNewRow);
                // tạo ra ô action
                var bActionCell = $("<td>").appendTo(bNewRow);
                // tạo ra 2 nút: sửa, xóa và gắn vào ô action
                $("<button>", {
                    html: "Sửa",
                    class: "btn btn-primary edit-user mr-2"
                }).data("id", paramUsers[bI].id)
                .appendTo(bActionCell);
                
                $("<button>", {
                    html: "Xóa",
                    class: "btn btn-danger delete-user"
                }).data("id", paramUsers[bI].id)
                .appendTo(bActionCell);
            }
        }
    </script>
</head>

<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>

</html>